#ifndef ZPU_H
#define ZPU_H

#define ZPU_IM               128   // OK
#define ZPU_BREAKPOINT       0     // OK
#define ZPU_PUSHSP           2     // OK
#define ZPU_POPPC            4     // OK
#define ZPU_ADD              5     // OK
#define ZPU_AND              6     // OK
#define ZPU_OR               7     // OK
#define ZPU_LOAD             8     // OK
#define ZPU_NOT              9     // OK
#define ZPU_FLIP             10    // OK
#define ZPU_NOP              11    // OK
#define ZPU_STORE            12    // OK
#define ZPU_POPSP            13    // OK
#define ZPU_ADDSP            16    // OK
#define ZPU_EMULATE          32
#define ZPU_LOADH            34    // OK
#define ZPU_STOREH           35    // OK
#define ZPU_LESSTHAN         36    // OK
#define ZPU_LESSTHANOREQUAL  37    // OK
#define ZPU_ULESSTHAN        38    // OK
#define ZPU_ULESSTHANOREQUAL 39    // OK
#define ZPU_SWAP             40    // OK
#define ZPU_MULT             41    // OK
#define ZPU_LSHIFTRIGHT      42    // OK
#define ZPU_ASHIFTLEFT       43    // OK
#define ZPU_ASHIFTRIGHT      44    // OK
#define ZPU_CALL             45    // OK
#define ZPU_EQ               46    // OK
#define ZPU_NEG              47    // OK
#define ZPU_NEQ              48    // OK
#define ZPU_SUB              49    // OK
#define ZPU_XOR              50    // OK
#define ZPU_LOADB            51    // OK
#define ZPU_STOREB           52    // OK
#define ZPU_DIV              53    // OK
#define ZPU_MOD              54    // OK
#define ZPU_EQBRANCH         55    // OK
#define ZPU_NEQBRANCH        56    // OK
#define ZPU_POPPCREL         57    // OK
#define ZPU_CONFIG           58    // OK
#define ZPU_PUSHPC           59    // OK
#define ZPU_SYSCALL          60
#define ZPU_PUSHSPADD        61    // OK
#define ZPU_MULT16X16        62    // OK
#define ZPU_CALLPCREL        63    // OK
#define ZPU_STORESP          64    // OK
#define ZPU_LOADSP           96    // OK

#define VECTORSIZE           0x20
#define VECTOR_RESET         0
#define VECTOR_INTERRUPT     1
#define VECTORBASE           0x0


void zpu_reset();
void zpu_execute();

#endif // ZPU_H
